unit startmain;

interface

uses
  Windows, Messages, SysUtils, Classes, HTTPApp;

type
  TWebModule1 = class(TWebModule)
    procedure WebModuleBeforeDispatch(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    function LogError(eType, Caller, Error :String):String;
  end;

var
  WebModule1: TWebModule1;

implementation

{$R *.DFM}

uses
  IniFiles, MutexHandling, ShellAPI;

{ TWebModule1 }
procedure TWebModule1.WebModuleBeforeDispatch(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
  MyMutex :HWND;
  MyTest : Boolean;
begin

try
  MyMutex := 0;
  //first let's try and get the mutex...
  try
    MyTest := CheckForMutex(MyMutex);
    if MyTest = True then
      Response.Content := 'TRUE'
    else
      begin
      if MyTest = False then
        Response.Content := Response.Content + '<HR>False'
      else
        Response.Content := Response.Content + '<HR>ERRRR';
      end;
  finally
      if MyMutex <> 0 then
        begin
          Response.Content := Response.Content + 'We Had a non zero mutex<hr>' + IntToStr(MyMutex);
          ReleaseMutex(MyMutex);
          CloseHandle(MyMutex);
        end;
    end;  //finally
  if MyTest = True then
    begin //no-one has the Mutex, thus we need to start the application...
    //notice that we've removed ownership of the mutex. For clarity we should have
    //a seperate mutex here to stop two applications trying to open the same thing
    Response.Content := Response.Content + 'we''re here';
    Response.Content := Response.Content + ExtractFilePath(ParamStr(0));

  ShellExecute(0, nil,
      PChar(ExtractFilePath(ParamStr(0)) + 'mainapp.exe'),
      nil, nil, SW_SHOWNORMAL);


    Response.Content := Response.Content + 'we''re here';
    end;

  //end outer try block
except
  on E :Exception do
    begin
      Response.Content := Response.Content + LogError(E.ClassName, 'General Before Dispath', E.Message);
    end;
  end;


//and comments for the next bit so Jon doesn't forget...
Response.Content := Response.Content + '<hr><b>JON</b> : Don''t forget to show LogError working!';

Response.SendResponse;
end;

function TWebModule1.LogError(eType, Caller, Error: String):String;
var
  Tempor :String;
  MyLog :TIniFile;
begin

MyLog := nil;

try
    MyLog := TIniFile.Create(ExtractFilePath(ParamStr(0)) + 'startapp.log');
    Tempor := eType + ' : ' + FormatDateTime('dd mmm yyyy hh:nn', Now());
    MyLog.WriteString(Caller, Tempor, Error);
    Result := '<hr>' + Caller + '<hr>' + Tempor + '<hr>' + Error;
finally
    if MyLog <> nil then
      FreeAndNil(MyLog);
  end;
end;


end.
